#include <iostream>
#include <algorithm>

using namespace std;

long long a[80000],b[80000],c[80000];
int result[10];

int main()
{
    int t,n,m,res=1;
    cin>>t;
    int p=t;
    for(int k=0;k<t;k++)
    {
        res=1;
        cin>>n>>m;
        for(int i=0;i<n;i++)
        {
            cin>>a[i];
        }
        for(int j=0;j<m;j++)
        {
            cin>>b[j];
        }
        sort(a,a+n);
        sort(b,b+m);
        c[0]=a[1]-a[0];
        int prev=c[0];
        for(int i=1;i<n-1;i++)
        {
            c[i]=a[i+1]-a[i];
            if(c[i]<prev)
            {
                if(prev%c[i]==0)
                {
                    prev=c[i];
                }
                else
                {
                    res=0;
                    break;
                }
            }
            else if(c[i]%prev!=0)
            {
                res=0;
                break;
            }
        }
        for(int i=0;i<m;i++)
        {
            b[i]-=a[0];
            if(b[i]%prev==0)
            {
                res=0;
                break;
            }
        }
        result[k]=res;
    }
    for(int i=0;i<t;i++)
    {
        cout<<result[i]<<endl;
    }
}